/* X-BASIC v2.0 ユーザーリファレンス p68-246のうち
// グラフィック関数
// グラフィックを使っている関数

float af,bf,cf
str as,bs,cs[40]
int col
width(64)
cls()

/* 下のwidth()テストのため表示を出す
print "val sample"
as="3000000000000"
bs="-2.51235e-2"
cs="0.5102123542131543512312313453543543513213"
af=val(as)
bf=val(bs)
cf=val(cs)
print af*bf*cf
print af/bf/cf
print

// カーソル位置を保存
int tx=pos(),ty=csrlin()
print "tx,ty=";tx,ty
// width(0)ではカーソルは移動しない
width(0)
int x0,y0
x0=pos()
y0=csrlin()
width(64):/* これでカーソルがhome(0,0)に移動する
print "width(0)後tx,ty=";x0,y0
print "width()後tx,ty=";pos(),csrlin()
locate(tx,ty+1):// カーソルを戻す

vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpageX68(1,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)
vpageX68(1)

//goto "VPAGE"

srand2()

int ai,bi,ci,di,ei=1

if YES then {

print "tan sample"
lineX68(0,255,511,255,&hffff)
for ai=1 to 3
	for bi = 0 to 511
		af=(2*pi()*bi)/512*ai
		if af>=ei*pi()/2 then ei=ei+2:continue
		ci=255-tan(af)*100
		di=rand2(65535)
		gColor(x68Color2iOSColor(di))
		pset(bi,ci)
	next
	ei=1
next
wait(2)
wipe()

print "sin sample"
lineX68(0,255,511,255,65535)
for ai=1 to 3
	for bi=0 to 511
		af=(2*pi()*bi)/512*ai
		ci=255-sin(af)*200
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next
wait(2)
wipe()

print "cos sample"
lineX68(0,255,511,255,65535)
for ai=1 to 3
	for bi=0 to 511
		af=(2*pi()*bi)/512*ai
		ci=255-cos(af)*200
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next
wait(2)
wipe()

print "atan sample"
lineX68(0,255,511,255,65535)
for ai=1 to 3
	for bi=0 to 511
		af=bi-255
		ci=255-atan(af)*ai*40
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next
wait(2)
wipe()

print "log sample"
lineX68(0,255,511,255,65535)
for ai =1 to 3
	for bi=1 to 511
		af=bi/150.05222#
		ci=255-log(af)*ai*60
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next
wait(2)
wipe()

print "abs sample"
lineX68(0,255,511,255,65535)
for ai = 1 to 5
	for bi=0 to 511
		af=(2*pi()*bi)/512*ai
		ci=255-abs(sin(af)*200)
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next

hitKey(YES)
wipe()

print "line sample(1)"
wipe()
srand2()
int fi,gi
for ai=0 to 100
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 512
	ei=rand() mod 512
	fi=rnd()*65535
	gi=65535
	lineX68(bi,ci,di,ei,fi,gi)
next
hitKey()
wipe()
print "line sample(2)"
for ai=0 to 100
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 512
	ei=rand() mod 512
	fi=rnd()*65535
	gi=rnd()*65535
	lineX68(bi,ci,di,ei,fi,gi)
next

hitKey(YES)
wipe()

print "box sample(1)"
for ai=0 to 100
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 512
	ei=rand() mod 512
	fi=rnd()*65535
	gi=65535
	boxX68(bi,ci,di,ei,fi,gi)
next
hitKey()
wipe()
print "box sample(2)"
	for ai=0 to 100
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 512
	ei=rand() mod 512
	fi=rnd()*65535
	gi=rnd()*65535
	boxX68(bi,ci,di,ei,fi,gi)
next

hitKey(YES)
wipe()

print "hsv sample"
for ai=0 to 15
	for bi=0 to 3
		for ci=0 to 2
			kyu(bi*128,ci*170,ai*12+bi*3+ci)
		next
	next
	wait(0.5)
next

hitKey(YES)
wipe()

locate(0,0):print "rgb sample"
width(0)
gLocate( 7, 4):print "0"
gLocate( 4,17):print "Blue"
gLocate(33, 4):print "Green"
gLocate(62, 4):print "31"
gLocate(6, 30):print "31"
width(64)
for ai=0 to 31
	locate( 1, 1):print "Red = ";ai
	for bi = 0 to 31
		for ci=0 to 31
			col=rgbX68(ai,bi,ci)
			gColor(col)
			fill(bi*14+64,ci*14+64,bi*14+78,ci*14+78)
		next
	next
	wait(0.5)
next

hitKey()
wipe()


print "circle sample(1)"
for ai=0 to 100
    bi=rand() mod 768
	ci=rand() mod 512
    di=rand() mod 200
    col=ai mod 16
	//print "col=";col;"/$";x6816Color2iOSColor(col)
	circle16X68(bi,ci,di,col,0,360)
next
hitKey()
wipe()

print "circle sample(2)"
for ai=0 to 256
	ci=hsvX68X68(ai mod 192,31,31)+1
//	print hex$(ci),
	circleX68(256,256,100,ci,0,360,ai)
	wait(0.05)
next
//for ai=0 to 500
//bi=500-ai
//ci=hsvX68(ai mod 192,31,31)
//circleX68(256,256,100,ci,0,360,bi)
//wait(0.05)
//next
hitKey()
wipe()

print "circle sample(3)"
locate(19, 8):print "弧"
locate(19,16):print "扇"
for ai = 0 to 17
	bi=ai*5
	ci=90-bi
	ei=90+bi
	print "角度:";ci;"〜";ei,-ci;"〜";-ei
	gi=hsvX68X68(ai mod 192,31,31)
	circleX68(256,200,150,gi, ci, ei)
	circleX68(256,439,150,gi,-ci,-ei)
	wait(0.3)
next

hitKey()
wipe()

print "pset sample"
for ai=1 to 5
	for bi=0 to 511
		af=(2*3.141#*bi)/512*ai
		ci=255-sin(af)*200
		di=rnd()*65535
		psetX68(bi,ci,di)
	next
next

hitKey()
wipe()


print "point sample(bitmap)"
ai=255
bi=255
di=1
ei=1
fi=0
enum
	sx=100
	sy=100
	ex=667
	ey=411
endenum
//line16X68(100,100,667,100, 3,(&HFFFF))
//line16X68(100,100,100,411, 9,(&HFFFF))
//line16X68(100,411,667,411,11,(&HFFFF))
//line16X68(667,100,667,411,13,(&HFFFF))
bitmapWipe()
int  c3=x6816Color2iOSColor( 3)
int  c9=x6816Color2iOSColor( 9)
int c11=x6816Color2iOSColor(11)
int c13=x6816Color2iOSColor(13)
int  c5=x6816Color2iOSColor( 5)
bitmapLine(sx,sy,ex,sy,c3)
bitmapLine(sx,sy,sx,ey,c9)
bitmapLine(sx,ey,ex,ey,c11)
bitmapLine(ex,sy,ex,ey,c13)
bitmapImgLoad()
int i=0
while YES
	wait(0.0005,NO)
	ai=ai+di
	bi=bi+ei
	ci=bitmapPoint(ai,bi)
	repeat
		// 境界線を見つけたら向きを変える
		if (ci= c3) then ei= 1:fi=1:break
		if (ci= c9) then di= 1:fi=1:break
		if (ci=c11) then ei=-1:fi=1:break
		if (ci=c13) then di=-1:fi=1:break
		// iOSでは色の違う線を重ねると別の色になるので、必ずしもこれらの色だけとは限らなくなる
		// それは、bitmapを使っても避けられない
	until YES
	if fi=1 then fi=0:continue:// 境界線上は描画しない
	// ここに来るときはci=c5または0または合成色
	if (ai>=ex or bi>=ey or ai<=sx or bi<=sy) then {
		// 何故か全部塗りつぶすを枠外に出てしまうのでその時は終了する；他の終了判定を見つけられなかったので
		print "col=$";hex$(ci)
		break
	}
	bitmapPset(ai,bi,c5)
	bitmapImgLoad()
	wait(0)
endwhile
hitKey()
wipe()

print "paint sample"
bitmapWipe()
for ai=0 to 50
	wait(0.0005,NO)
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 200
	ei=rnd()*65535
	bitmapCircle(bi,ci,di,x68Color2iOSColor(ei))
	wait(0)
next
bitmapImgLoad()
for ai=0 to 300
	wait(0.0005,NO)
	bitmapPaint(rnd()*511,rnd()*511,x68Color2iOSColor(rnd()*65535))
	bitmapImgLoad()
	wait(0)
next
hitKey()
wipe()
for ai=0 to 50
	wait(0.0005,NO)
	bi=rand() mod 512
	ci=rand() mod 512
	di=rand() mod 512
	ei=rand() mod 512
	fi=rnd()*65535
	bitmapBox(bi,ci,di,ei,x68Color2iOSColor(fi))
	wait(0)
next
bitmapImgLoad()
for ai = 0 to 300
	wait(0.0005,NO)
	bitmapPaint(rnd()*511,rnd()*511,x68Color2iOSColor(rnd()*65535))
	bitmapImgLoad()
	wait(0)
next

hitKey()
wipe()

print "apage sample"
str fontname="mikachan_o-P"
vpageX68(&B1111)
for ai = 0 to 8
	/* active page(0)
	apage(GPAGE0)
	bi=rnd()*15
	fill16X68(50,50,200,200,bi)
	symbol16X68(210, 50,"アクティブページ0",1,bi,fontname)
	wait(1)
	/* active page(1)
	apage(GPAGE1)
	bi=rnd()*15
	fill16X68(100,100,250,250,bi)
	symbol16X68(260,100,"アクティブページ1",1,bi,fontname)
	wait(1)
	/* active page(2)
	apage(GPAGE2)
	bi=rnd()*15
	fill16X68(150,150,300,300,bi)
	symbol16X68(310,150,"アクティブページ2",1,bi,fontname)
	wait(1)
	/* active page(3)
	apage(GPAGE3)
	bi=rnd()*15
	fill16X68(200,200,350,350,bi)
	symbol16X68(360,200,"アクティブページ3",1,bi,fontname)
	wait(1)
next

hitKey()
wipe()

/* wipe sample
vpriority(GPAGE3,GPAGE2,GPAGE1,GPAGE0,TPAGE)
vpageX68(0)
apageX68(0):fill16X68(50,50,460,260,9):kyu1(200,0,9)
apageX68(1):kyu1(200,15,0)
apageX68(2):kyu1(150,11,0):symbol16X68(170,166,"SHARP" ,3,5,fontname)
apageX68(3):kyu1(100,13,0):symbol16X68(202,196,"X68000",1,3,fontname)
/*
vpageX68(&B1111)
for ai=1 to 3
	print "グラフィックページ" ; ai ; "をワイプします "
	wait(2)
	apageX68(ai)
	wipe()
next
print"グラフィックページ 0 をワイプします"
wait(2)
apageX68(0)
wipe()


} // if NO

vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)

label "VPAGE"
cls()
print "vpage sample"
// ごめんなさい、X68実機ほどスムースに動きません
vpageX68(0):// すべて表示しない
apageX68(0):kyu2(400, 0,5)
apageX68(1):kyu2(320,10,4)
apageX68(2):kyu2(240,20,3)
apageX68(3):kyu2(160,30,2)
for i=0 to 4
//while YES
	for ai=0 to 511
		af=pi()*ai/512*2
		bi=abs(sin(pi()/2-af)*400)
//		print bi,
		if bi=0 then {
			vpageX68(&B0010):wait(0.2)
			vpageX68(&B0100):wait(0.2)
			vpageX68(&B1000):wait(0.2)
			vpageX68(&B0100):wait(0.2)
			vpageX68(&B0010):wait(0.2)
		}
		wait(0.001,YES)
		homeX68(0,0,bi):homeX68(1,0,bi)
		homeX68(2,0,bi):homeX68(3,0,bi)
		vpageX68(&B1)
		wait(0)
	next
//endwhile
next

hitKey(YES)
wipe()

// ごめんなさい、X68実機ほどスムースに動きません
print "home sample"
apageX68(0):kyu3(0)
apageX68(1):kyu3(1)
apageX68(2):kyu3(2)
apageX68(3):kyu3(3)
vpageX68(15)
for i=0 to 4
//while YES
	for ai = 0 to 511
		wait(0.001,YES)
		af = pi()*ai/512
		bi = sin(af)*511
		homeX68(0,    ai,bi):homeX68(1,bi,    ai)
		homeX68(2,511-ai,bi):homeX68(3,bi,511-ai)
		wait(0)
	next
//endwhile
next
end

//------------------

func kyu(di;int,ei;int,fi;int)
int gi,hi,ii
fillX68(di,ei,di+127,ei+169,0)
for gi=0 to 31
	hi=31-gi
	gColor(hsvX68(fi,31,gi))
	circle(di+64,ei+64,hi*2+ii)
next
endfunc

func kyu1(ai,bi,ci)
	while ai>0
		circle16X68(256,256,ai,bi,-10,-170)
		ai=ai-1
	endwhile
// iOSにはビットマップ以外paintがないので、半径を0まで同じ色で描画することで同じ効果を作っている
//	paint(256,250,bi)
	//
	ai=30
	while ai>0
		circle16X68(256,256,ai,ci,0,180)
		ai=ai-1
	endwhile
//	paint(256,250,ci )
endfunc

func kyu2(ai,bi,ci)
	circle16X68(256,461+bi,50,5,0,360,ai)
//	int r=50
//	while r>0
//		circle16X68(256,461+bi,r,ci,0,360,ai)
//		r=r-1
//	endwhile
endfunc

func kyu3(ai)
	int r=50
	while r>0
		circle16X68(128,128,r,ai*4+1)
		r=r-1
	endwhile
	r=50
	while r>0
		circle16X68(256,256,r,ai*4+2)
		r=r-1
	endwhile
	r=50
	while r>0
		circle16X68(384,384,r,ai*4+3)
		r=r-1
	endwhile
endfunc

