/* X-BASIC v2.0 ユーザーリファレンス p60-61
/* 2.5.2 文字列操作
/* X-BASICでは、ファイル操作などで扱う文字列に対して、いろいろな文字列操作を行う関数を数多く用意しています。
/* ●指定された文字の種類を調べる関数……(isalnum、isalphaなど)
/* ●文字列から指定された文字や文字列を検索する関数……(instr、strchr、strcspnなど)
/* ●指定された文字や文字列を変換する関数……(mirror$、strlwr、strnset、toasciiなど)
/* ●文字列から指定された文字を区切り文字とした文字列に分解する関数……(strtok)
/* ●指定された文字でできた文字列を作成する関数……(space$、string$、strsetなど)
/* ●文字列と数値を変換する関数……(asc、atof、bin$、chr$、ecvtなど)
/* ファイルの1文字修正サンプルです
// for V3.00
int ai,bi,po
str as,bs,cs,ds,che1,che2,syu1,syu2
//screen 2,0,1,1
cls()
linput"ファイル名を入力してください:";as
ai=fopen(as,"c")
while -1
	print"'X68'を入力すると一旦ファイルをクローズします
	linput"文字や文字列を入力してください:";bs
	/* chr$(13)=CR,chr$(10)=LF,chr$(26)=EOF
	if bs="X68" then bs=bs+chr$(26):break
	bs=bs+chr$(13)+chr$(10)
	fwrites(bs,ai)
endwhile
fwrites(bs,ai)
fclose(ai)
/* update
hitKey(YES)
linput"修正はありますか？<y/n>:";che1
if che1="n" or che1="N" then end
linput "修正後のデータを格納するフアイル名を入力してください:";bs
ai=fopen(as,"rw")
bi=fopen(bs,"c")
repeat
	cls()
	freads(cs,ai)
	print cs
	int length=strlen(cs)
	linput "この中に修正する文字はありますか？<y/n>:";che1
	if che1<>"y" then {
		cs=cs+chr$(13)+chr$(10)
		fwrites(cs,bi)
		continue
	}
	while YES
		linput "修正したい1文字を入力してください:";syu1
		po=strchr(cs,asc(syu1))
		if po=-1 then print"該当文字がありません!!":continue
		linput "修正後の1文字を入力してくだい:";syu2 /* 削除の場合はこの行を取る
		ds=cs
		cs=left$(cs,po)+syu2+right$(cs,length-po-1) /*削除の場合はこの行の"+syu2"を取る
		print "次のように修正します"
		print cs
		linput "よろしいですか？<y/n>:";che2
		if che2<>"n" then {
			cs=cs+chr$(13)+chr$(10)
			fwrites(cs,bi)
			break
		}
		cs=ds
		print cs
	endwhile
until feof(ai)=-1
/*
hitKey(YES)
print "修正前のファイルの内容と修正後のファイルの内容を表示します"
fseek(ai,0,0)
fseek(bi,0,0)
print "修正前のファイルの内容を表示します"
repeat
	freads(cs,ai)
	print cs
until feof(ai)=-1
print "修正後のファイルの内容を表示します"
repeat
	freads(ds,bi)
	print ds
until feof(bi)=-1
fcloseall()
end
